/*----------------------------------------------------------------------------*/
/*	(C) Copyright IBM Corporation 1997, 2006.  All Rights Reserved.       */
/*	                                                                      */
/*	IBM CONFIDENTIAL                                                      */
/*	                                                                      */
/*	OCO SOURCE MATERIALS	                                              */
/*----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

/*
wismp(int *One, int *Two, int *Three, double aFour[],  double aFive[], int *Six, double aSeven[], int *Eight, int *Nine, double aTen[], double aEleven[],
		 		 		 int *Twelve, double *aThirteen);
*/
int main(int argc,char **argv)
{
        int n, ldb, ldx, ldy, nrhs;
        int iparm[64];
        //int ia[10];
        //int ja[53];
        double dparm[64];
        //double avals[53];
        double b[9], x[9], y[9];

        double *rmisc, *cvgh; //     ! just placeholders in this program

        int i;
        double waltime, rtc;
        int nthrds;

//C.. Fill all arrays containing matrix data.

        n = 9; ldb = 9; ldx = 9; ldy = 9; nrhs = 1;
        int ia[] = {0, 4, 9, 15, 20, 25, 32, 38, 47, 53};

        int ja[]  = {
     0,          2,                      6,    7,
     0,    1,    2,                            7,    8,
     0,    1,    2,                      6,    7,    8,
     0, 	       3,          5,    6,    7,
     	   1,                4,    5,          7,    8,
     		 2,    3,    4,    5,    6,    7,    8,
     0,          2,    3,          5,    6,    7,
     0,    1,    2,    3,    4,    5,    6,    7,    8,
           1,    2,          4,    5,          7,    8
		 };

     double avals[] = { 
     14.0,       -1.0,                   -1.0, -3.0,
      9.0, 14.0, -1.0,                         -3.0, -1.0,
     -1.0, -1.0, 16.0,                   -2.0, -4.0, -2.0,
      8.0,             14.0,       -1.0, -1.0, -3.0,
            7.0,             14.0, -1.0,       -3.0, -1.0,
                  6.0, -1.0, -1.0, 16.0, -2.0, -4.0, -2.0,
     -1.0,       -2.0, -1.0,       -2.0, 16.0, -4.0,
     -3.0, -3.0, -4.0, -3.0, -3.0, -4.0, -4.0, 71.0, -4.0,
           -1.0, -2.0,       -1.0, -2.0,       -4.0, 16.0
		 };

//C.. Executable part of the program starts here.

//C.. Fill 'iparm' and 'dparm' arrays with default values.

        iparm[0] = 0;
        iparm[1] = 0;
        iparm[2] = 0;
        wismp (&n, ia, ja, avals, b, &ldb, x, &ldx, &nrhs,rmisc, cvgh, iparm, dparm);
        if (iparm[63] != 0) {
          printf("The following ERROR was detected: %d", iparm[63]);
          exit(0);
        }

//C.. Modify some defaults

	iparm[7] = 2;  //	 	! no matching
	iparm[9] = 0;  //	 	! no scaling
	iparm[14] = 0;  //	 	! no preconditioning
	iparm[15] = -1;  //	 	! no reordering

//C.. Analyze structure.

        iparm[1] = 1;
        iparm[2] = 1;
        wismp (&n, ia, ja, avals, b, &ldb, x, &ldx, &nrhs,rmisc, cvgh, iparm, dparm);
        if (iparm[63] != 0) {
          printf("The following ERROR was detected: %d",iparm[63]);
         exit(0);
        }

//C.. Analyze Values.

        iparm[1] = 2;
        iparm[2] = 2;
        wismp (&n, ia, ja, avals, b, &ldb, x, &ldx, &nrhs,rmisc, cvgh, iparm, dparm);
        if (iparm[63] != 0) {
          printf("The following ERROR was detected: %d",iparm[63]);
         exit(0);
        }

	for (i = 0; i < n; i++) {
          x[i] = (double) (i + 1);
	}
        iparm[1] = 5;
        iparm[2] = 5;
        wismp (&n, ia, ja, avals, b, &ldb, x, &ldx, &nrhs,rmisc, cvgh, iparm, dparm);
        if (iparm[63] != 0) {
          printf("The following ERROR was detected: %d", iparm[63]);
          exit(0);
        }
	return 0;
}

